/*
 * @(#)AdminURLServlet.java	1.20 97/10/13
 * 
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */

import java.io.*;
import java.net.InetAddress;

import javax.servlet.*;
import javax.servlet.http.*;

import com.sun.server.*;
import com.sun.server.http.*;

import com.sun.server.PropertyConfig;
import com.sun.server.ServerParameters;

/**
 * Admin URL servlet. This servlet will find out the port number of
 * the admin servlet and use it to create and return the href. 
 *
 * <P> NOTE:  This servlet relies on internal APIs of the Java Web
 * Server, which are subject to change.
 */
public
class AdminURLServlet extends HttpServlet {

    public void doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
      {
	try {
	    //
	    // get Admin Service handles
	    //

	    ServerParameters sp = new ServerParameters("adminserver");
	    String serviceName = "adminservice";
	    //String prop = "server.adminserver.service.adminservice.endpoint.main.port";
	    File serviceDir = new File(sp.getConfigDir() +
				       File.separatorChar + serviceName);
	    PropertyConfig config = new PropertyConfig(serviceDir);
	    Integer port = new Integer(config.getProperty("endpoint.main.port"));


	    Service adminService = ServiceManager.getService("adminservice");
	    ServiceParameters adminParams = 
		adminService.getParameters();
	    ServiceEndpoint ep = (adminService.getEndpoints())[0];

	    //
	    // use transport endpoint to get network addressing info
	    //
	    int    adminPort = port.intValue();
	    String adminHost = ep.getInterface();
	    
	    if (adminHost.equals("*"))
		adminHost = ServerProcess.getParameters ().getDefaultHost();

	    //
	    // construct a HTML "href" to identify the URL
	    // normally used to address the admin servlet.
	    //
	    StringBuffer hrefString = new StringBuffer();

// XXX doesn't address case of using HTTPS !!

	    hrefString.append("<a href=\"http://");
	    hrefString.append(adminHost);
	    hrefString.append(":");
	    hrefString.append(adminPort);
	    hrefString.append("/index.html\">");
	    hrefString.append("Start the Administration Tool</a>");
	    String outString = hrefString.toString();

	    ServletOutputStream out = res.getOutputStream();
	    out.println(outString);

	} catch (IOException e) {
	    throw e;

	} catch (Exception exc) {
	    throw new ServletException (
		"Cannot create administration tool URL: " + exc.getMessage());
	}
    }

    public String getServletInfo() {
	return "A servlet that constructs the URL for the admin applet.";
    }

    private static void debug(String message) {
	if (debugging) {
	    System.err.println("AdminURLServlet: " + message);
	}
    }
    private static final boolean debugging = false;

}
