/*
 * @(#)RoomSchedApplet.java	1.7 97/03/03
 * 
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */

package com.sun.server.calendar;

import java.awt.*;
import java.applet.Applet;
import java.util.*;
import java.io.*;
import java.net.*;

/**
 * RoomSchedApplet
 * First version of Calendar frontend with room scheduling
 * capability
 *
 * @author Rob Clark
 * @version  1.7, 03/03/97
 */

public class RoomSchedApplet extends Applet {		
  
    // a slot to hold an arbitrary object pointer that can
    // be filled in by the app. and referenced in actions
    public Object arg;
  
    public Label titleLabel;
    public Button previousWeek;
    public Label weekLabel;
    public Button nextWeek;
    public Button todayButton;
    public WeeklyCanvas canvas_1;
    public Label roomLabel;
    public Choice confRoom;
    public Label todayMeetingLabel;
    public List todayMeetingList;
    public Label dateLabel;
    public Choice monthChoice;
    public Choice dayChoice;
    public Label startLabel;
    public Choice startChoice;
    public Label endLabel;
    public Choice endChoice;
    public Label attendeesLabel;
    public Label descriptionLabel;
    public Label requestorLabel;
    public TextField attendeesText;
    public TextArea descriptionText;
    public TextField requestorText;
    public Button addButton;
    public Button modifyButton;

    public String times[] = {
	"8:00am", "8:30am", "9:00am", "9:30am",
	"10:00am", "10:30am", "11:00am", "11:30am",
	"12:00pm", "12:30pm", "1:00pm", "1:30pm",
	"2:00pm", "2:30pm", "3:00pm", "3:30pm",
	"4:00pm", "4:30pm", "5:00pm", "5:30pm", "6:00pm"};

    Date today = new Date();
    Date working;
    //TumbleItem tumbler;
    int nimgs = 16;

    public final String FONTNAME = "Helvetica";
    //public final String FONTNAME = "interface user";

    private void loadPictures() {
	Image[] imgs = new Image[nimgs];
	MediaTracker tracker = new MediaTracker(this);
	try {
	    for (int i = 1; i < nimgs; i++) {
		URL url = new URL(getDocumentBase(), "com.sun.server/calendar/" +
				  "T" + i + ".gif");
		imgs[i] = getImage(url);
		tracker.addImage(imgs[i], 0);
		p(url.toString());
	    }
	    tracker.waitForID(0);
	} catch (Exception e) {
	    System.out.println("Error loading images:" + e.toString());
	}
	//tumbler.loadPictures(imgs, System.out);
    }

    public void init() {
    
	int i=0;
	working = today;

	/*
	tumbler = new TumbleItem();
	loadPictures();
	tumbler.init();
	tumbler.start();
	*/

	// main panel
	GridBagLayout grid = new GridBagLayout();
	GridBagConstraints con = new GridBagConstraints();

	//int rowHeights[] = {0,30,30,30,30,30,10,30,86,10,30,30,30,30,8,30,10,30,20,30,30,30};
	//int columnWidths[] = {0,30,20,50,20,30,255,10,30,78,123,53};
	//grid.rowHeights = rowHeights;
	//grid.columnWidths = columnWidths;

	setBackground(new Color(238, 238, 255));

	//
	// new Panel
	//
	Panel p = new Panel();
	p.setLayout(grid);
	previousWeek = new Button("<<");
	previousWeek.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	reset(con);
	con.gridx = 1;
	con.gridy = 1;
	grid.setConstraints(previousWeek, con);
	p.add(previousWeek);

	weekLabel = new Label("                              ");
	weekLabel.setFont(new Font(FONTNAME,Font.BOLD , 14));
	reset(con);
	con.gridx = 2;
	con.gridy = 1;
	con.anchor = GridBagConstraints.WEST;
	grid.setConstraints(weekLabel, con);
	p.add(weekLabel);

	nextWeek = new Button(">>");
	nextWeek.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	reset(con);
	con.gridx = 3;
	con.gridy = 1;
	grid.setConstraints(nextWeek, con);
	p.add(nextWeek);

	todayButton = new Button("today");
	todayButton.setFont(new Font(FONTNAME,Font.BOLD , 14));
	reset(con);
	con.gridx = 4;
	con.gridy = 1;
	grid.setConstraints(todayButton, con);
	p.add(todayButton);

	//
	// new panel
	//
	Panel pp = new Panel();
	grid = new GridBagLayout();
	pp.setLayout(grid);

	roomLabel = new Label("Room:");
	roomLabel.setFont(new Font(FONTNAME,Font.BOLD , 14));
	reset(con);
	con.gridx = 1;
	con.gridy = 1;
	con.anchor = GridBagConstraints.EAST;
	grid.setConstraints(roomLabel, con);
	pp.add(roomLabel);

	confRoom = new Choice();
	confRoom.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	confRoom.addItem("Blue Jeans (#2403)");
	reset(con);
	con.gridx = 2;
	con.gridy = 1;
	con.gridwidth = 3;
	con.anchor = GridBagConstraints.WEST;
	grid.setConstraints(confRoom, con);
	pp.add(confRoom);

	todayMeetingLabel = new Label("Today's Meetings:");
	todayMeetingLabel.setFont(new Font(FONTNAME,Font.BOLD , 14));
	reset(con);
	con.gridx = 1;
	con.gridy = 2;
	con.gridwidth = 4;
	grid.setConstraints(todayMeetingLabel, con);
	pp.add(todayMeetingLabel);


	//
	// new panel
	//
	Panel ppp = new Panel();
	grid = new GridBagLayout();
	ppp.setLayout(grid);
	dateLabel = new Label("Date:");
	dateLabel.setFont(new Font(FONTNAME, Font.BOLD, 14));
	reset(con);
	con.gridx = 1;
	con.gridy = 1;
	con.anchor = GridBagConstraints.EAST;
	grid.setConstraints(dateLabel, con);
	ppp.add(dateLabel);

	monthChoice = new Choice();
	monthChoice.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	monthChoice.addItem("January");
	monthChoice.addItem("February");
	monthChoice.addItem("March");
	monthChoice.addItem("April");
	monthChoice.addItem("May");
	monthChoice.addItem("June");
	monthChoice.addItem("July");
	monthChoice.addItem("August");
	monthChoice.addItem("September");
	monthChoice.addItem("October");
	monthChoice.addItem("November");
	monthChoice.addItem("December");
	monthChoice.select(today.getMonth());
	reset(con);
	con.gridx = 2;
	con.gridy = 1;
	con.gridwidth = 2;
	con.anchor = GridBagConstraints.WEST;
	grid.setConstraints(monthChoice, con);
	ppp.add(monthChoice);
    
	dayChoice = new Choice();
	dayChoice.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	for (i=1; i<32; i++) dayChoice.addItem(Integer.toString(i));
	//dayChoice.select(today.getDate()-1);
	reset(con);
	con.gridx = 4;
	con.gridy = 1;
	grid.setConstraints(dayChoice, con);    
	ppp.add(dayChoice);

	//label_1.setText(monthChoice.getSelectedItem() + " " + (1900 + today.getYear()));
    

	startLabel = new Label("Start:");
	startLabel.setFont(new Font(FONTNAME,Font.BOLD , 14));
	reset(con);
	con.gridx = 1;
	con.gridy = 2;
	con.anchor = GridBagConstraints.EAST;
	grid.setConstraints(startLabel, con);
	ppp.add(startLabel);

	startChoice = new Choice();
	startChoice.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	for (i=0; i<times.length-1; i++) {
	    startChoice.addItem(times[i]);
	}
	reset(con);
	con.gridx = 2;
	con.gridy = 2;
	con.gridwidth = 3;
	con.anchor = GridBagConstraints.WEST;
	grid.setConstraints(startChoice, con);
	ppp.add(startChoice);

	endLabel = new Label("End:");
	endLabel.setFont(new Font(FONTNAME,Font.BOLD , 14));
	reset(con);
	con.gridx = 1;
	con.gridy = 3;
	con.anchor = GridBagConstraints.EAST;
	grid.setConstraints(endLabel, con);
	ppp.add(endLabel);

	endChoice = new Choice();
	endChoice.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	for (i=1; i<times.length; i++) {
	    endChoice.addItem(times[i]);
	}
	reset(con);
	con.gridx = 2;
	con.gridy = 3;
	con.gridwidth = 3;
	con.anchor = GridBagConstraints.WEST;
	grid.setConstraints(endChoice, con);
	ppp.add(endChoice);

	requestorLabel = new Label("Requestor:");
	requestorLabel.setFont(new Font(FONTNAME,Font.BOLD , 14));
	reset(con);
	con.gridx = 1;
	con.gridy = 4;
	con.anchor = GridBagConstraints.EAST;
	grid.setConstraints(requestorLabel, con);
	ppp.add(requestorLabel);

	attendeesLabel = new Label("Attendees:");
	attendeesLabel.setFont(new Font(FONTNAME,Font.BOLD , 14));
	reset(con);
	con.gridx = 1;
	con.gridy = 5;
	con.anchor = GridBagConstraints.EAST;
	grid.setConstraints(attendeesLabel, con);
	ppp.add(attendeesLabel);

	descriptionLabel = new Label("Description:");
	descriptionLabel.setFont(new Font(FONTNAME,Font.BOLD , 14));
	reset(con);
	con.gridx = 1;
	con.gridy = 6;
	con.anchor = GridBagConstraints.EAST;
	grid.setConstraints(descriptionLabel, con);
	ppp.add(descriptionLabel);

	requestorText = new TextField();
	requestorText.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	reset(con);
	con.gridx = 2;
	con.gridy = 4;
	con.gridwidth = 3;
	con.fill = GridBagConstraints.BOTH;
	grid.setConstraints(requestorText, con);
	ppp.add(requestorText);

	attendeesText = new TextField();
	attendeesText.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	reset(con);
	con.gridx = 2;
	con.gridy = 5;
	con.gridwidth = 3;
	con.fill = GridBagConstraints.BOTH;
	grid.setConstraints(attendeesText, con);
	ppp.add(attendeesText);

	descriptionText = new TextArea(3, 10);
	descriptionText.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	reset(con);
	con.gridx = 2;
	con.gridy = 6;
	con.gridwidth = 3;
	con.gridheight = 3;
	con.fill = GridBagConstraints.BOTH;
	grid.setConstraints(descriptionText, con);
	ppp.add(descriptionText);

	addButton = new Button("Add");
	addButton.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	reset(con);
	con.gridx = 1;
	con.gridy = 9;
	con.anchor = GridBagConstraints.EAST;
	grid.setConstraints(addButton, con);
	ppp.add(addButton);

	modifyButton = new Button("Modify");
	modifyButton.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	reset(con);
	con.gridx = 3;
	con.gridy = 9;
	grid.setConstraints(modifyButton, con);
	ppp.add(modifyButton);



	//
	// global panel
	//
	grid = new GridBagLayout();
	setLayout(grid);

	/*
	reset(con);
	con.gridx = 1;
	con.gridy = 0;
	con.gridwidth = 2;
	con.fill = GridBagConstraints.BOTH;
	grid.setConstraints(tumbler, con);
	add(tumbler);
	*/

	reset(con);
	titleLabel = new Label("Jeeves Conference Room Scheduler");
	titleLabel.setFont(new Font(FONTNAME,Font.BOLD , 18));
	con.gridx = 1;
	con.gridy = 1;
	con.gridwidth = 2;
	con.anchor = GridBagConstraints.CENTER;
	grid.setConstraints(titleLabel, con);
	add(titleLabel);

	reset(con);
	con.gridx = 1;
	con.gridy = 2;
	con.fill = GridBagConstraints.HORIZONTAL;
	grid.setConstraints(p, con);
	add(p);

	canvas_1 = new WeeklyCanvas();
	reset(con);
	con.gridx = 1;
	con.gridy = 3;
	con.gridheight = 3;
	con.weightx = 1;
	con.weighty = 1;
	con.anchor = GridBagConstraints.NORTH;
	con.fill = GridBagConstraints.BOTH;
	grid.setConstraints(canvas_1, con);
	add(canvas_1);

	reset(con);
	con.gridx = 2;
	con.gridy = 3;
	con.anchor = GridBagConstraints.NORTH;
	grid.setConstraints(pp, con);
	add(pp);

	todayMeetingList = new List(5, false);
	todayMeetingList.setFont(new Font(FONTNAME,Font.PLAIN , 14));
	reset(con);
	con.gridx = 2;
	con.gridy = 4;
	//con.gridwidth = 4;
	//con.gridheight = 7;
	//con.weighty = 0.5;
	con.fill = GridBagConstraints.BOTH;
	con.anchor = GridBagConstraints.NORTH;
	grid.setConstraints(todayMeetingList, con);
	add(todayMeetingList);

	reset(con);
	con.gridx = 2;
	con.gridy = 5;
	con.anchor = GridBagConstraints.NORTHWEST;
	grid.setConstraints(ppp, con);
	add(ppp);

	setDate(today);
    }

    public boolean action(Event e, Object o) {
	if (e.target instanceof Choice) {
	    Choice c = (Choice) e.target;
	    if ((c == startChoice) &&
		(startChoice.getSelectedIndex() >= endChoice.getSelectedIndex())) { 
		endChoice.select(startChoice.getSelectedIndex());
		return true;
	    } else if ((c == endChoice) &&
		     (startChoice.getSelectedIndex() >= endChoice.getSelectedIndex())) { 
		startChoice.select(endChoice.getSelectedIndex());
		return true;
	    } else if ((c == dayChoice) || (c == monthChoice)) {
		working = new Date(working.getYear(),
				   monthChoice.getSelectedIndex(),
				   dayChoice.getSelectedIndex()+1);
		setDate(working);
		return true;
	    }
      
	}
	else if (e.target instanceof Button) {
	    Button b = (Button) e.target;
	    if (b == todayButton) {
		working = today;
		setDate(working);
		return true;
	    } else if (b == previousWeek) {
		working = new Date(working.getYear(),
				   working.getMonth(),
				   working.getDate() -7 );
		setDate(working);
		return true;
	    } else if (b == nextWeek) {
		working = new Date(working.getYear(),
				   working.getMonth(),
				   working.getDate() + 7);
		setDate(working);
		return true;
	    } else if (b == addButton) {
		addNewSchedule("add");
		canvas_1.repaint();
		return true;
	    } else if (b == modifyButton) {
		addNewSchedule("modify");
		canvas_1.repaint();
		return true;
	    }
	}

	return false;
    }

    public boolean handleEvent(Event e) {
	if (e.id == Event.MOUSE_UP && e.target == canvas_1) {
	    working = new Date(working.getYear(),
			       working.getMonth(),
			       working.getDate()-(working.getDay()-canvas_1.clickedColumn) + 1);
	    setControl(working);
	    fillInfo();
	    resizeChoice();
	    return true;
	} else if (e.id == Event.LIST_SELECT &&
		   e.target == todayMeetingList) {
	    canvas_1.selectSchedule(todayMeetingList.getSelectedItem(),
				    working);
	    fillInfo();
	    resizeChoice();
	}

	return super.handleEvent(e);
    }


    private void fillInfo() {
	if (canvas_1.schedSelected == null) {
	    return;
	}
	startChoice.select(canvas_1.schedSelected.start);
	endChoice.select(canvas_1.schedSelected.end-1);
	requestorText.setText(canvas_1.schedSelected.requestor);
	attendeesText.setText(canvas_1.schedSelected.attendees);
	descriptionText.setText(canvas_1.schedSelected.message);
    }

    private void resizeChoice() {
	Container c = startChoice.getParent();
	Dimension dim = c.preferredSize();
	Dimension d = c.size();
	int height = (dim.height == d.height) ? d.height - 1 : dim.height;
	c.resize(dim.width, height);
    }

    private String getTime(String time) {
	int index = time.indexOf(":");
	String retval;

	retval = time.substring(0, index);

	int min = Integer.parseInt(time.substring(index+1, index+3));
	if (min == 30) {
	    retval = retval + ".5";
	}

	return retval;
    }

    private void fetchSchedule(Date date) {
	Hashtable ht = new Hashtable();
	ht.put("action", "get");
	ht.put("year", String.valueOf(date.getYear()));
	ht.put("month", String.valueOf(date.getMonth()));
	ht.put("day", String.valueOf(date.getDate()));
	ServletMessage msg;
	try {
	    msg = new ServletMessage(new URL(getDocumentBase(),
					     "/servlet/roomsched"));
	} catch (Exception e) {
	    e.printStackTrace();
	    return;
	}
	ServletResponse res = msg.sendMessage(ht, ServletMessage.POST);
	updateColumn(res, date);
    }

    private void addNewSchedule(String what) {
	String attendees = attendeesText.getText();
	if (attendees == null) {
	    attendees = "none";
	}
	Hashtable ht = new Hashtable();
	ht.put("action", what);
	ht.put("starttime", String.valueOf(startChoice.getSelectedIndex()));
	ht.put("endtime", String.valueOf(endChoice.getSelectedIndex()+1));
	ht.put("month", String.valueOf(monthChoice.getSelectedIndex()));
	ht.put("day", dayChoice.getSelectedItem());
	ht.put("year", String.valueOf(working.getYear()));
	ht.put("attendees", attendeesText.getText());
	ht.put("entry", descriptionText.getText());
	ht.put("requestor", requestorText.getText());

	ServletMessage msg;
	try {
	    msg = new ServletMessage(new URL(getDocumentBase(),
					     "/servlet/roomsched"));
	} catch (Exception e) {
	    e.printStackTrace();
	    return;
	}

	ServletResponse res = msg.sendMessage(ht, ServletMessage.POST);

	updateColumn(res, working);
	setControl(working);
    }

    private void updateColumn(ServletResponse res, Date when) {

	String current;
	Vector schedules = new Vector();
	Schedule sched = null;
	Schedule nsched;
	int count = 0;

	try {
	    DataInputStream din = new DataInputStream(res.getInputStream());
	    current = din.readLine();
	    while (current != null) {
		p("Reading " + current);
		if (current.equals("empty-na")) {
		    if (sched != null) {
			sched.end = count;
			schedules.addElement(sched);
			sched = null;
		    }
		} else {
		    nsched = new Schedule();
		    nsched.start = count;
		    nsched.requestor = current;
		    nsched.attendees = din.readLine();
		    p("Attendees " + nsched.attendees);
		    nsched.message = din.readLine();
		    p("Message " + nsched.message);
		    current = din.readLine();
		    p("Next " + current);
		    while (!current.equals("empty-na")) {
			nsched.message = nsched.message.concat("\n" + current);
			current = din.readLine();
			p("Next " + current);
		    }
		    if (sched == null) {
			sched = nsched;
		    } else if (!sched.requestor.equals(nsched.requestor) ||
			       !sched.attendees.equals(nsched.attendees) ||
			       !sched.message.equals(nsched.message)) {
			sched.end = count;
			schedules.addElement(sched);
			sched = nsched;
		    }
		}

		count++;
		current = din.readLine();
	    }
	} catch (Exception e) {
	    e.printStackTrace();
	}

	//System.out.println("Updating " + schedules.toString() + " " + when.toString());
	canvas_1.setColumn(schedules, when);
    }


    private void setControl(Date d) {
	dayChoice.select(d.getDate()-1);
	monthChoice.select(d.getMonth());
	int cnt = todayMeetingList.countItems();
	todayMeetingList.delItems(0, cnt - 1);
	int day = d.getDay() - 1;
	if (day < 0 || day > 4) {
	    return;
	}
	Vector v = canvas_1.schedules[d.getDay() - 1];
	if (v == null) {
	    return;
	}
	Enumeration e = v.elements();
	String buf;
	while (e.hasMoreElements()) {
	    Schedule s = (Schedule) e.nextElement();
	    buf = s.message;
	    buf = (buf.indexOf('\n') != -1) ?
		buf.substring(0, buf.indexOf('\n')) :
		buf;
	    todayMeetingList.addItem(buf);
	}
	attendeesText.setText("");
	requestorText.setText("");
	descriptionText.setText("");
    }


    private void setDate(Date d) {
	Date monday = getPreviousMonday(d);
	Date friday = new Date(monday.getYear(), monday.getMonth(),
			       monday.getDate() + 4);
	setWeek(monday);
	setControl(d);
	weekLabel.setText(monthChoice.getSelectedItem() + " " +
			  monday.getDate() + "-" +
			  friday.getDate() + " " + (1900 + d.getYear()));
    }

    private Date getPreviousMonday(Date d) {
	return new Date(d.getYear(), d.getMonth(), d.getDate()-d.getDay()+1);
    }

    private void setWeek(Date monday) {
	Date date = monday;
	Vector sched;
    
	for (int i = 0; i < 5; i++) {
	    fetchSchedule(date);
	    date = new Date(date.getYear(), date.getMonth(), date.getDate() + 1);
	}
	canvas_1.repaint();
    }

    private void reset(GridBagConstraints con) {
	con.gridx = GridBagConstraints.RELATIVE;
	con.gridy = GridBagConstraints.RELATIVE;
	con.gridwidth = 1;
	con.gridheight = 1;
    
	con.weightx = 0;
	con.weighty = 0;
	con.anchor = GridBagConstraints.CENTER;
	con.fill = GridBagConstraints.NONE;
    
	con.insets = new Insets(4, 0, 4, 2);
	con.ipadx = 0;
	con.ipady = 0;
    }
    
    private void p(String s) {
	//System.out.println(s);
    }
}
